SystemOrganization addCategory: #'Shout-Parsing'!
SystemOrganization addCategory: #'Shout-Styling'!
SystemOrganization addCategory: #'Shout-Examples'!

!ProcessBrowser methodsFor: '*Shout-Styling' stamp: 'AlainPlantec 8/27/2011 00:03'!
shoutAboutToStyle: aPluggableShoutMorphOrView

	selectedContext ifNil: [^false].
	aPluggableShoutMorphOrView classOrMetaClass: self selectedClass.
	^ true
! !

!MessageSet methodsFor: '*Shout-Styling' stamp: 'AlainPlantec 8/27/2011 00:16'!
shoutAboutToStyle: aPluggableShoutMorphOrView 
	self shoutIsModeStyleable
		ifFalse: [^ false].
	aPluggableShoutMorphOrView classOrMetaClass: self selectedClass.
	^ true! !

!HelpBrowser methodsFor: '*Shout-Styling' stamp: 'AlainPlantec 8/28/2011 13:52'!
shoutAboutToStyle: aPluggableShoutMorphOrView 
	^ false! !

!FileList methodsFor: '*Shout-Styling' stamp: 'AlainPlantec 8/27/2011 00:26'!
shoutAboutToStyle: aPluggableShoutMorphOrView 
	^ false! !

!FlatMessageListBrowser methodsFor: '*Shout-Styling' stamp: 'AlainPlantec 8/27/2011 14:59'!
shoutAboutToStyle: aPluggableShoutMorphOrView

	aPluggableShoutMorphOrView classOrMetaClass: self selectedClassOrMetaClass.
	self preference = self sourceLabel
		ifTrue: [^ true].
	self preference = self byteCodeLabel
		ifTrue: [^ false].
	self preference = self infoLabel
		ifTrue: [	^ false].
	self preference = self diffLabel 
		ifTrue: [^ true].
	^ false! !

!MCTool methodsFor: '*Shout-Styling' stamp: 'AlainPlantec 8/27/2011 15:59'!
shoutAboutToStyle: aPluggableShoutMorphOrView
	^ false! !

!FinderUI methodsFor: '*Shout-Styling' stamp: 'AlainPlantec 8/26/2011 23:56'!
shoutAboutToStyle: aPluggableShoutMorphOrView

	aPluggableShoutMorphOrView classOrMetaClass: self selectedClass.
	self selectedClass isNil
		ifTrue: [	^ false].
	self selectedMethod isNil
		ifTrue: [^ false].
	^ true! !

!Browser methodsFor: '*Shout-Styling' stamp: 'AlainPlantec 8/27/2011 00:52'!
shoutAboutToStyle: aPluggableShoutMorphOrView 
	| type |
	self shoutIsModeStyleable
		ifFalse: [^ false].
	type := self editSelection.
	(#(#newMessage #editMessage #editClass #newClass ) includes: type)
		ifFalse: [^ false].
	aPluggableShoutMorphOrView
		classOrMetaClass: (type = #editClass
				ifFalse: [self selectedClassOrMetaClass]).
	^ true! !

!Debugger methodsFor: '*Shout-Styling' stamp: ''!
shoutAboutToStyle: aPluggableShoutMorphOrView 
	self shoutIsModeStyleable
		ifFalse: [^ false].
	aPluggableShoutMorphOrView classOrMetaClass: self selectedClassOrMetaClass.
	^ true! !

!ChangeSorter methodsFor: '*Shout-Styling' stamp: ''!
shoutAboutToStyle: aPluggableShoutMorphOrView 
	self shoutIsModeStyleable
		ifFalse: [^ false].
	self currentSelector
		ifNil: [^ false].
	aPluggableShoutMorphOrView classOrMetaClass: self selectedClassOrMetaClass.
	^ true! !

!StringHolder methodsFor: '*Shout-Styling' stamp: 'AlainPlantec 8/27/2011 01:16'!
shoutAboutToStyle: aPluggableShoutMorphOrView 
	^ false! !

Model subclass: #SHMethodEditingMode
	instanceVariableNames: 'code className selector classIsMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shout-Examples'!

!SHMethodEditingMode commentStamp: 'AlainPlantec 9/20/2011 21:15' prior: 0!
This example shows how to use shout for method editing. Try it with:

SHMethodEditingMode new open

For method editing, you need to provide a class to the styler. When a class is given, the styler is automatically turned into a method editing mode.
The styler is then able to style the code according to the class bindings (instance variables names, shared pool...)
See #shoutAboutToStyle. 
  - First, the class is given to the styler by sending #classOrMetaClass: to the view with the class as argument.
  - Finally, in this example, #shoutAboutToStyle returns true because the code is always to be styled.

Instance Variables
	className:		<String>
	code:		<String>

className
	- The class name for the styler

code
	- the code which is entered into the editor  
!

!SHMethodEditingMode methodsFor: 'accessing' stamp: 'AlainPlantec 9/20/2011 08:58'!
classIsMeta
	^ classIsMeta ifNil: [classIsMeta := false]! !

!SHMethodEditingMode methodsFor: 'accessing' stamp: 'AlainPlantec 9/20/2011 10:00'!
classIsMeta: aBoolean
	classIsMeta := aBoolean.
	self selector: nil.
	self changed: #selector.
	self changed: #classIsMeta.
	self code: ''.
! !

!SHMethodEditingMode methodsFor: 'accessing' stamp: 'AlainPlantec 9/19/2011 22:12'!
className
	^ className ifNotNil: [className asSymbol]! !

!SHMethodEditingMode methodsFor: 'accessing' stamp: 'AlainPlantec 9/20/2011 10:00'!
className: aClassName
	className := aClassName copyWithout: Character cr.
	self selector: nil.
	self changed: #selector.
	self changed: #className.
	self selectedClass
		ifNotNil: [	self changed: #haveClassName]! !

!SHMethodEditingMode methodsFor: 'view' stamp: 'AlainPlantec 9/20/2011 08:32'!
classSelector
	| applicantsBlock entryCompletion |
	applicantsBlock := [(Array
				streamContents: [:strm | Symbol
						allSymbolTablesDo: [:each | (each notEmpty
									and: [each first canBeGlobalVarInitial
											and: [Smalltalk globals includesKey: each]])
								ifTrue: [strm nextPut: each]]]) sort].
	entryCompletion := EntryCompletion new
				dataSourceBlock: [:currText | applicantsBlock value ];
				filterBlock: [:currApplicant :currText | currText size > 0
						and: [currApplicant asUppercase includesSubString: currText asString asUppercase]].
	^ (UIManager default newAutoAcceptTextEntryFor: self
			get: #className
			set: #className:
			class: String 
			getEnabled: nil
			help: 'Enter a class name' translated
			entryCompletion: entryCompletion)
				acceptOnCR: false;
				ghostText: 'Class name';
				withDropListButton;
				yourself.
! !

!SHMethodEditingMode methodsFor: 'accessing' stamp: 'AlainPlantec 9/20/2011 09:21'!
classToUse
	^ self selectedClass
		ifNotNil: [self classIsMeta 
				ifTrue: [self selectedClass class]
				ifFalse: [self selectedClass]]! !

!SHMethodEditingMode methodsFor: 'accessing' stamp: 'AlainPlantec 9/19/2011 21:26'!
code
	^ code ifNil: [code := '' asText]! !

!SHMethodEditingMode methodsFor: 'accessing' stamp: 'AlainPlantec 9/20/2011 09:55'!
code: someText
	code := someText.
	self changed: #code! !

!SHMethodEditingMode methodsFor: 'accessing' stamp: 'AlainPlantec 9/20/2011 09:19'!
haveClassName
	^ self selectedClass notNil! !

!SHMethodEditingMode methodsFor: 'view' stamp: 'AlainPlantec 9/20/2011 09:13'!
metaSwitch
	^ UIManager default
		newCheckboxFor: self
		getSelected: #classIsMeta
		setSelected: #classIsMeta:
		label: 'Class'
		help: 'Class side is used if checked' ! !

!SHMethodEditingMode methodsFor: 'view' stamp: 'AlainPlantec 9/20/2011 09:19'!
methodSelector
	| entryCompletion applicantsBlock |
	applicantsBlock := [self selectedClass 
						ifNil: [#()] 
						ifNotNil: [:clsn | self classToUse selectors asArray sort ]].
	entryCompletion := EntryCompletion new
				dataSourceBlock: [:currText | applicantsBlock value];
				filterBlock: [:currApplicant :currText | currText size > 0
						and: [currApplicant asUppercase includesSubString: currText asString asUppercase]].
	^ (UIManager default newAutoAcceptTextEntryFor: self
			get: #selector
			set: #selector:
			class: String 
			getEnabled: #haveClassName
			help: 'Enter a selector' translated
			entryCompletion: entryCompletion) 
				acceptOnCR: false;
				ghostText: 'Selector';
				withDropListButton;
				yourself.
! !

!SHMethodEditingMode methodsFor: 'view' stamp: 'AlainPlantec 9/20/2011 08:59'!
open
	| window bar editor |
	window := (StandardWindow labelled: 'Method editor with shout') model: self.
	editor := window newTextEditorFor:  self getText:  #code setText: #code: getEnabled: nil. 
	window addMorph: (window newColumn: { window newRow: { self classSelector. self metaSwitch. self methodSelector}. editor} )
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1)).
	^ window openInWorld! !

!SHMethodEditingMode methodsFor: 'accessing' stamp: 'AlainPlantec 9/20/2011 09:18'!
selectedClass
	self className ifNil: [ ^ nil ]. 
	^ Smalltalk globals at: self className ifAbsent: []! !

!SHMethodEditingMode methodsFor: 'accessing' stamp: 'AlainPlantec 9/20/2011 07:55'!
selector
	^ selector! !

!SHMethodEditingMode methodsFor: 'accessing' stamp: 'AlainPlantec 9/20/2011 10:00'!
selector: aSymbol
	selector := aSymbol ifNotNil: [:sel |( sel copyWithout: Character cr) asSymbol].
	self changed: #selector.
	self classToUse 
		ifNotNil: [:cls | (cls selectors includes: selector)
			ifTrue: [self code: (cls sourceCodeAt: selector)]]! !

!SHMethodEditingMode methodsFor: 'shout' stamp: 'AlainPlantec 9/20/2011 09:19'!
shoutAboutToStyle: ATextView
	ATextView classOrMetaClass: self classToUse.
	^ true! !

Model subclass: #SHOneEditorShoutedASecondNotShouted
	instanceVariableNames: 'code comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shout-Examples'!

!SHOneEditorShoutedASecondNotShouted commentStamp: 'AlainPlantec 9/20/2011 17:23' prior: 0!
In this example, the view has two text editors. 
Try it with:

SHOneEditorShoutedASecondNotShouted  new open.

The top view is supposed to be used for code editing and the other for comment editing.
Only the code editor view has to be highligthed whereas the comment editor is never highligthed. In this case, the model must implement a #shoutAboutToStyle: method which returns true. When the view is built, the comment pane is setup to forbid code styling by sending #styled: to it with false as argument. See the #open method and the #styled: sent.

Instance Variables:
	code	<Text>
	comment	<Text>!

!SHOneEditorShoutedASecondNotShouted methodsFor: 'accessing' stamp: 'AlainPlantec 9/1/2011 18:48'!
code
	^ code ifNil: [code := '' asText]! !

!SHOneEditorShoutedASecondNotShouted methodsFor: 'accessing' stamp: 'AlainPlantec 9/3/2011 18:35'!
code: someText
	code := someText.
	self changed: #code! !

!SHOneEditorShoutedASecondNotShouted methodsFor: 'accessing' stamp: 'AlainPlantec 9/1/2011 18:49'!
comment
	^ comment ifNil: [comment := '' asText]! !

!SHOneEditorShoutedASecondNotShouted methodsFor: 'accessing' stamp: 'AlainPlantec 9/3/2011 18:35'!
comment: someText
	comment := someText.
	self changed: #comment! !

!SHOneEditorShoutedASecondNotShouted methodsFor: 'view' stamp: 'AlainPlantec 9/19/2011 22:40'!
open
	| window codeEditor commentEditor |
	window := (StandardWindow labelled: 'A styled editor and a not styled one for the same model') model: self.
	codeEditor := window newTextEditorFor:  self getText:  #code setText: #code: getEnabled: nil. 
	commentEditor := window newTextEditorFor:  self getText:  #comment setText: #comment: getEnabled: nil. 
	"now, comment must not be highlighted: just send #styled: to the editor with false as argument"
	commentEditor styled: false.
	window addMorph: codeEditor frame: (0@0 extent: 1@0.5).
	window addMorph: commentEditor frame: (0@0.5 extent: 1@1).
	^ window openInWorld! !

!SHOneEditorShoutedASecondNotShouted methodsFor: 'shout' stamp: 'AlainPlantec 9/19/2011 19:45'!
shoutAboutToStyle: ATextView
	^ true! !

Model subclass: #SHStylingOrNotDependingOnModelState
	instanceVariableNames: 'code codeEditing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shout-Examples'!

!SHStylingOrNotDependingOnModelState commentStamp: 'AlainPlantec 9/20/2011 17:26' prior: 0!
I'm a example that shows how to have a simple editor in which text is highlighted or not depending on the editor model state.  Try it with:

SHStylingOrNotDependingOnModelState new open.

Thus, depending on the model state, the view should be styled or not styled. This is achieve by implementing a #shoutAboutToStyle: method in the model (here, an instance of myself). #shoutAboutToStyle: returns true if the view which is passed as argument must be styled. In this excample, if the value of the 'state' instance variable is #code, then the text is hilighted, else it is not.

Instance Variables:
	code	<Text>
	codeEditing    <Boolean>!

!SHStylingOrNotDependingOnModelState methodsFor: 'accessing' stamp: 'AlainPlantec 9/1/2011 18:58'!
code
	^ code ifNil: [code := '' asText]! !

!SHStylingOrNotDependingOnModelState methodsFor: 'accessing' stamp: 'AlainPlantec 9/3/2011 18:30'!
code: someText
	code := someText.
	self changed: #code! !

!SHStylingOrNotDependingOnModelState methodsFor: 'accessing' stamp: 'AlainPlantec 9/3/2011 16:23'!
codeEditing
	^ codeEditing ifNil: [codeEditing := true]! !

!SHStylingOrNotDependingOnModelState methodsFor: 'accessing' stamp: 'AlainPlantec 9/19/2011 19:44'!
codeEditing: aBoolean
	codeEditing = aBoolean ifTrue: [^self].
	codeEditing := aBoolean.
	self changed: #code.
! !

!SHStylingOrNotDependingOnModelState methodsFor: 'view' stamp: 'AlainPlantec 9/19/2011 22:07'!
open
	| window editor bar |
	window := (StandardWindow labelled: 'Code and text editor') model: self.
	bar := window newRow: {
			window 
				newCheckboxFor: self 
				getSelected: #codeEditing 
				setSelected: #codeEditing:
				label: 'Code editing' 
				help: 'Checked for code editing' }.
	editor := window newTextEditorFor:  self getText:  #code setText: #code: getEnabled: nil. 
	window addMorph: (window newColumn: {bar. editor})
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1)).
	^ window openInWorld! !

!SHStylingOrNotDependingOnModelState methodsFor: 'shout' stamp: 'AlainPlantec 9/3/2011 18:29'!
shoutAboutToStyle: ATextView
	^ self codeEditing! !

Model subclass: #SHWorkspaceEditingMode
	instanceVariableNames: 'code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shout-Examples'!

!SHWorkspaceEditingMode commentStamp: 'AlainPlantec 9/20/2011 17:13' prior: 0!
By default, shout styling is into a method editing mode. If you need a script editor for example, then you have to setup shout into a workspace mode. In order to setup a workspace mode, one have to make it available the workspace instance to the view styler. Typically, the workspace inspace is the model instance itself. See the sent of the #workspace: message into the #open method:

open
	...
	editor := window newTextEditorFor:  self getText:  #code setText: #code: getEnabled: nil. 
	editor styler workspace: self. 
	...
	^ window openInWorld

The workspace class has also to implement #hasBindingOf: and #hasBindingThatBeginsWith:. In fact, #hasBindingOf: and #hasBindingThatBeginsWith: are sent to the workspace by shout during styling. As an example, see the #bindings method implemented here:

bindings
	^ #('shout' 'styling')

It returns a list of symbols which is used by #hasBindingOf: and #hasBindingThatBeginsWith:. 
Then open an editor with:

SHWorkspaceEditingMode new open

If you enter the word 'shout' as an example, you will see that the word is recognized as a variable name.
!

!SHWorkspaceEditingMode methodsFor: 'private bindings' stamp: 'AlainPlantec 9/20/2011 16:54'!
bindings
	^ #('shout' 'example')! !

!SHWorkspaceEditingMode methodsFor: 'accessing' stamp: 'AlainPlantec 9/4/2011 10:19'!
code
	^ code ifNil: [code := '' asText]! !

!SHWorkspaceEditingMode methodsFor: 'accessing' stamp: 'AlainPlantec 9/4/2011 10:19'!
code: someText
	code := someText.
	self changed: #code! !

!SHWorkspaceEditingMode methodsFor: 'bindings' stamp: 'AlainPlantec 9/4/2011 10:30'!
hasBindingOf: aString
	^ self bindings includes: aString asSymbol.! !

!SHWorkspaceEditingMode methodsFor: 'bindings' stamp: 'AlainPlantec 9/4/2011 10:31'!
hasBindingThatBeginsWith: aString
	^ self bindings anySatisfy: [:s | s beginsWith: aString]
! !

!SHWorkspaceEditingMode methodsFor: 'view' stamp: 'AlainPlantec 9/20/2011 17:16'!
open
	| window editor |
	window := (StandardWindow labelled: 'Editor with Workspace like  syntax highlighting') model: self.
	editor := window newTextEditorFor:  self getText:  #code setText: #code: getEnabled: nil. 
	"Set-up the styler to be in workspace mode"
	editor styler workspace: self.
	window addMorph: editor frame: (0@0 extent: 1@1).
	^ window openInWorld! !

!SHWorkspaceEditingMode methodsFor: 'shout' stamp: 'AlainPlantec 9/19/2011 20:52'!
shoutAboutToStyle: ATextView
	^ true! !

!CodeHolder methodsFor: '*Shout-Styling' stamp: ''!
shoutIsModeStyleable
	^ self showingSource
		or: [self showingPrettyPrint]! !

!MessageListBrowser methodsFor: '*Shout-Styling' stamp: 'AlainPlantec 8/27/2011 15:04'!
shoutAboutToStyle: aPluggableShoutMorphOrView

	self selectedNode ifNil: [^false].
	aPluggableShoutMorphOrView classOrMetaClass: self selectedNode getClass.
	self preference = self sourceLabel
		ifTrue: [^ true].
	self preference = self byteCodeLabel
		ifTrue: [^ false].
	self preference = self infoLabel
		ifTrue: [	^ false].
	self preference = self versionLabel
		ifTrue:[ ^ false].
	self preference = self diffLabel 
		ifTrue: [^ false].
! !

!PluggableTextMorph methodsFor: '*Shout' stamp: ''!
stylerStyled: styledCopyOfText 
	textMorph contents runs: styledCopyOfText runs.
	textMorph updateFromParagraph.
	selectionInterval
		ifNotNil: [textMorph editor selectInvisiblyFrom: selectionInterval first to: selectionInterval last;
				 storeSelectionInParagraph;
				 setEmphasisHere].
	textMorph editor blinkParen.
	self scrollSelectionIntoView! !

!PluggableTextMorph methodsFor: '*Shout' stamp: ''!
stylerStyledInBackground: styledCopyOfText 
	textMorph contents string = styledCopyOfText string
		ifTrue: [self stylerStyled: styledCopyOfText]! !

!FileContentsBrowser methodsFor: '*Shout-Styling' stamp: ''!
shoutAboutToStyle: aPluggableShoutMorphOrView 
	self shoutIsModeStyleable
		ifFalse: [^ false].
	aPluggableShoutMorphOrView classOrMetaClass: self selectedClassOrMetaClass.
	^ true! !

!TextAttribute methodsFor: '*Shout-styling' stamp: ''!
shoutShouldPreserve
	^ false! !

!TimeProfiler methodsFor: '*Shout-Styling' stamp: 'AlainPlantec 8/26/2011 22:45'!
shoutAboutToStyle: aPluggableShoutMorphOrView 
	self selectedNode
		ifNotNil: [ :currNode | 
			aPluggableShoutMorphOrView getTextSelector = #selectedMethodCode
				ifTrue: [aPluggableShoutMorphOrView classOrMetaClass: currNode methodClass.
					^ true]].
	aPluggableShoutMorphOrView getTextSelector = #summaryText
			ifTrue: [^ false].
	aPluggableShoutMorphOrView getTextSelector = #blockCode
			ifTrue: [^ true].
	 ^ false
! !

!TextAction methodsFor: '*Shout-styling' stamp: ''!
shoutShouldPreserve
	^ true! !

!DiffMorph methodsFor: '*Shout-Styling' stamp: 'AlainPlantec 8/28/2011 13:44'!
shoutAboutToStyle: aPluggableShoutMorphOrView
	aPluggableShoutMorphOrView classOrMetaClass: self contextClass.
	^ self contextClass notNil ! !

Object subclass: #SHParserST80
	instanceVariableNames: 'classOrMetaClass source workspace arguments sourcePosition currentToken currentTokenFirst temporaries instanceVariables errorBlock currentTokenSourcePosition blockDepth bracketDepth ranges environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shout-Parsing'!

!SHParserST80 class methodsFor: 'instance creation' stamp: ''!
new
	^ super new initialize; yourself! !

!SHParserST80 methodsFor: 'scan' stamp: ''!
-= aSymbol 
	^ 1 -= 2! !

!SHParserST80 methodsFor: 'accessing' stamp: ''!
classOrMetaClass: aClass 
	classOrMetaClass := aClass! !

!SHParserST80 methodsFor: 'scan' stamp: ''!
currentChar
	^ source
		at: sourcePosition
		ifAbsent: []! !

!SHParserST80 methodsFor: 'parse support' stamp: ''!
enterBlock
	blockDepth := blockDepth + 1.
	bracketDepth := bracketDepth + 1! !

!SHParserST80 methodsFor: 'accessing' stamp: ''!
environment: anObject 
	environment := anObject! !

!SHParserST80 methodsFor: 'error handling' stamp: ''!
error
	self
		rangeType: #excessCode
		start: (ranges isEmpty
				ifTrue: [1]
				ifFalse: [ranges last end + 1])
		end: source size.
	errorBlock value! !

!SHParserST80 methodsFor: 'error handling' stamp: ''!
failUnless: aBoolean 
	aBoolean
		ifFalse: [self error]! !

!SHParserST80 methodsFor: 'error handling' stamp: ''!
failWhen: aBoolean 
	aBoolean
		ifTrue: [self error]! !

!SHParserST80 methodsFor: 'accessing' stamp: ''!
initialize
	environment := Smalltalk! !

!SHParserST80 methodsFor: 'parse support' stamp: ''!
initializeInstanceVariables
	instanceVariables := classOrMetaClass notNil
				ifTrue: [classOrMetaClass allInstVarNames asArray]
				ifFalse: [Set new]! !

!SHParserST80 methodsFor: 'token testing' stamp: ''!
isAnsiAssignment
	^ currentToken = ':='! !

!SHParserST80 methodsFor: 'token testing' stamp: ''!
isAssignment
	^ currentToken = ':='
		or: [currentToken = '_']! !

!SHParserST80 methodsFor: 'character testing' stamp: ''!
isBigDigit: aCharacter base: anInteger 
	| digitValue |
	digitValue := aCharacter digitValue.
	^ digitValue >= 0
		and: [digitValue < anInteger]! !

!SHParserST80 methodsFor: 'token testing' stamp: ''!
isBinary
	| char |
	(currentToken isNil
			or: [self isName
					or: [self isKeyword]])
		ifTrue: [^ false].
	1
		to: currentToken size
		do: [:i | 
			char := currentToken at: i.
			(self isSelectorCharacter: char)
				ifFalse: [^ false]].
	^ true! !

!SHParserST80 methodsFor: 'identifier testing' stamp: ''!
isBlockArgName: aString 
	| temp arg |
	blockDepth
		to: 1
		by: -1
		do: [:level | 
			arg := (arguments
						at: level
						ifAbsent: [#()])
						includes: aString.
			arg
				ifTrue: [^ true].
			temp := (temporaries
						at: level
						ifAbsent: [#()])
						includes: aString.
			temp
				ifTrue: [^ false]].
	^ false! !

!SHParserST80 methodsFor: 'identifier testing' stamp: ''!
isBlockTempName: aString 
	| temp arg |
	blockDepth
		to: 1
		by: -1
		do: [:level | 
			arg := (arguments
						at: level
						ifAbsent: [#()])
						includes: aString.
			arg
				ifTrue: [^ false].
			temp := (temporaries
						at: level
						ifAbsent: [#()])
						includes: aString.
			temp
				ifTrue: [^ true]].
	^ false! !

!SHParserST80 methodsFor: 'identifier testing' stamp: ''!
isIncompleteBlockArgName: aString 
	| arg |
	blockDepth
		to: 1
		by: -1
		do: [:level | 
			arg := (arguments
						at: level
						ifAbsent: [#()])
						anySatisfy: [:each | each beginsWith: aString].
			arg
				ifTrue: [^ true]].
	^ false! !

!SHParserST80 methodsFor: 'identifier testing' stamp: ''!
isIncompleteBlockTempName: aString 
	| temp |
	blockDepth
		to: 1
		by: -1
		do: [:level | 
			temp := (temporaries
						at: level
						ifAbsent: [#()])
						anySatisfy: [:each | each beginsWith: aString].
			temp
				ifTrue: [^ true]].
	^ false! !

!SHParserST80 methodsFor: 'identifier testing' stamp: ''!
isIncompleteMethodArgName: aString 
	^ (arguments
		at: 0
		ifAbsent: [#()])
		anySatisfy: [:each | each beginsWith: aString]! !

!SHParserST80 methodsFor: 'identifier testing' stamp: ''!
isIncompleteMethodTempName: aString 
	^ (temporaries
		at: 0
		ifAbsent: [#()])
		anySatisfy: [:each | each beginsWith: aString]! !

!SHParserST80 methodsFor: 'token testing' stamp: ''!
isKeyword
	^ (currentTokenFirst isLetter
			or: [currentTokenFirst == $_])
		and: [currentToken last == $:]! !

!SHParserST80 methodsFor: 'identifier testing' stamp: ''!
isMethodArgName: aString 
	^ (arguments
		at: 0
		ifAbsent: [#()])
		includes: aString! !

!SHParserST80 methodsFor: 'identifier testing' stamp: ''!
isMethodTempName: aString 
	((arguments
			at: 0
			ifAbsent: [#()])
			includes: aString)
		ifTrue: [^ false].
	^ (temporaries
		at: 0
		ifAbsent: [#()])
		includes: aString! !

!SHParserST80 methodsFor: 'token testing' stamp: ''!
isName
	^ (currentTokenFirst isLetter
			or: [currentTokenFirst == $_])
		and: [currentToken last isAlphaNumeric
				or: [currentToken last == $_]]! !

!SHParserST80 methodsFor: 'character testing' stamp: ''!
isSelectorCharacter: aCharacter 
	aCharacter isAlphaNumeric
		ifTrue: [^ false].
	aCharacter isSeparator
		ifTrue: [^ false].
	('"#$'':().;[]{}^_' includes: aCharacter)
		ifTrue: [^ false].
	aCharacter asciiValue = 30
		ifTrue: [^ false].
	aCharacter asciiValue = 0
		ifTrue: [^ false].
	^ true! !

!SHParserST80 methodsFor: 'token testing' stamp: ''!
isTokenExternalFunctionCallingConvention
	| descriptorClass |
	descriptorClass := Smalltalk
				at: #ExternalFunction
				ifAbsent: [].
	descriptorClass
		ifNil: [^ false].
	^ (descriptorClass callingConventionFor: currentToken) notNil! !

!SHParserST80 methodsFor: 'parse support' stamp: ''!
leaveBlock
	arguments
		removeKey: blockDepth
		ifAbsent: [].
	temporaries
		removeKey: blockDepth
		ifAbsent: [].
	blockDepth := blockDepth - 1.
	bracketDepth := bracketDepth - 1! !

!SHParserST80 methodsFor: 'scan' stamp: ''!
nextChar
	sourcePosition := sourcePosition + 1.
	^ source
		at: sourcePosition
		ifAbsent: [Character space]! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parse
	^ self parse: classOrMetaClass notNil! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parse: isAMethod 
	self initializeInstanceVariables.
	sourcePosition := 1.
	arguments := Dictionary new.
	temporaries := Dictionary new.
	blockDepth := bracketDepth := 0.
	ranges isNil
		ifTrue: [ranges := OrderedCollection new: 100]
		ifFalse: [ranges reset].
	errorBlock := [^ false].
	[self scanNext.
	isAMethod
		ifTrue: [self parseMessagePattern.
			self parsePragmaSequence].
	self parseMethodTemporaries.
	isAMethod
		ifTrue: [self parsePragmaSequence].
	self parseStatementList.
	currentToken
		ifNotNil: [self error]]
		ensure: [errorBlock := nil].
	^ true! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseArray
	[currentTokenFirst == $)]
		whileFalse: [self parseLiteralArrayElement].
	self scanPast: #arrayEnd! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseBinary
	| binary type |
	self parseUnary.
	[self isBinary]
		whileTrue: [binary := currentToken.
			type := #binary.
			(binary isEmpty
					or: [Symbol
							hasInterned: binary
							ifTrue: [:sym | nil]])
				ifFalse: [type := (Symbol thatStartsCaseSensitive: binary skipping: nil) isNil
								ifTrue: [#undefinedBinary]
								ifFalse: [#incompleteBinary]].
			self scanPast: type.
			self parseTerm.
			self parseUnary]! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseBinaryMessagePattern
	self scanPast: #patternBinary.
	self failUnless: self isName.
	self scanPast: #patternArg! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseBlock
	self enterBlock.
	self scanPast: #blockStart level: bracketDepth.
	currentTokenFirst == $:
		ifTrue: [self parseBlockArguments].
	currentTokenFirst == $|
		ifTrue: [self parseBlockTemporaries].
	self parseStatementList.
	self failUnless: currentTokenFirst == $].
	self scanPast: #blockEnd level: bracketDepth.
	self leaveBlock! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseBlockArguments
	[currentTokenFirst == $:]
		whileTrue: [self scanPast: #blockArgColon.
			self failUnless: self isName.
			self scanPast: #blockPatternArg].
	currentTokenFirst == $|
		ifTrue: [^ self scanPast: #blockArgsBar]! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseBlockTemporaries
	currentTokenFirst == $|
		ifTrue: [self scanPast: #blockTempBar.
			[self isName]
				whileTrue: [self scanPast: #blockPatternTempVar].
			self failUnless: currentToken = '|'.
			self scanPast: #blockTempBar]! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseBraceArray
	self parseStatementListForBraceArray.
	self failUnless: currentTokenFirst == $}.
	self scanPast: #rightBrace! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseByteArray
	[currentTokenFirst == $]]
		whileFalse: [self scanPast: #integer].
	self scanPast: #byteArrayEnd! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseCascade
	self parseKeyword.
	[currentTokenFirst == $;]
		whileTrue: [self scanPast: #cascadeSeparator.
			self parseKeyword]! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseCharSymbol
	| s e |
	s := sourcePosition - 1.
	e := sourcePosition.
	self nextChar.
	self
		scanPast: #symbol
		start: s
		end: e! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseExpression
	| assignType |
	self isName
		ifTrue: [self
				scanPast: (self resolve: currentToken).
			self isAssignment
				ifTrue: [assignType := self isAnsiAssignment
								ifTrue: [#ansiAssignment]
								ifFalse: [#assignment].
					self scanPast: assignType.
					self parseExpression]
				ifFalse: [self parseCascade]]
		ifFalse: [self parseTerm.
			self parseCascade]! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseExternalCall
	self scanNext.
	self scanPast: #externalCallType.
	currentToken = '*'
		ifTrue: [self scanPast: #externalCallTypePointerIndicator].
	currentTokenFirst isDigit
		ifTrue: [self scanPast: #integer]
		ifFalse: [self failUnless: currentTokenFirst == $'.
			self parseString].
	self failUnless: currentTokenFirst == $(.
	self scanPast: #leftParenthesis.
	[currentTokenFirst ~~ $)]
		whileTrue: [self scanPast: #externalCallType.
			currentToken = '*'
				ifTrue: [self scanPast: #externalCallTypePointerIndicator]].
	self scanPast: #rightParenthesis.
	currentToken = 'module:'
		ifTrue: [self scanPast: #module.
			self failUnless: currentTokenFirst == $'.
			self parseString].
	self failUnless: currentToken = '>'.
	self scanPast: #primitiveOrExternalCallEnd! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseKeyword
	| keyword rangeIndices |
	self parseBinary.
	keyword := ''.
	rangeIndices := #().
	[[self isKeyword]
		whileTrue: [keyword := keyword , currentToken.
			self rangeType: #keyword.
			rangeIndices := rangeIndices copyWith: ranges size.
			self scanNext.
			self parseTerm.
			self parseBinary].
	nil]
		ensure: [| type | (keyword isEmpty
					or: [Symbol
							hasInterned: keyword
							ifTrue: [:sym | nil]])
				ifFalse: [type := (Symbol thatStartsCaseSensitive: keyword skipping: nil) isNil
								ifTrue: [#undefinedKeyword]
								ifFalse: [#incompleteKeyword].
					rangeIndices
						do: [:i | (ranges at: i)
								type: type]]]! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseKeywordMessagePattern
	[self isKeyword]
		whileTrue: [self scanPast: #patternKeyword.
			self failUnless: self isName.
			self scanPast: #patternArg]! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseLiteral: inArray 
	| pos c |
	currentTokenFirst == $$
		ifTrue: [self failWhen: self currentChar isNil.
			self rangeType: #'$'.
			pos := currentTokenSourcePosition + 1.
			self nextChar.
			^ self
				scanPast: #character
				start: pos
				end: pos].
	currentTokenFirst isDigit
		ifTrue: [^ self scanPast: #number].
	currentToken = '-'
		ifTrue: [c := self currentChar.
			(inArray
					and: [c isNil
							or: [c isDigit not]])
				ifTrue: [^ self scanPast: #symbol].
			self scanPast: #-.
			self failWhen: currentToken isNil.
			^ self scanPast: #number].
	currentTokenFirst == $'
		ifTrue: [^ self parseString].
	currentTokenFirst == $#
		ifTrue: [^ self parseSymbol].
	(inArray
			and: [currentToken notNil])
		ifTrue: [^ self scanPast: #symbol].
	self failWhen: currentTokenFirst == $..
	self error! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseLiteralArrayElement
	| type |
	(currentTokenFirst isLetter
			or: [currentTokenFirst == $_])
		ifTrue: [type := (#('true' 'false' 'nil' ) includes: currentToken)
						ifTrue: [currentToken asSymbol]
						ifFalse: [#symbol].
			^ self scanPast: type].
	currentTokenFirst == $(
		ifTrue: [self scanPast: #arrayStart.
			^ self parseArray].
	currentTokenFirst == $[
		ifTrue: [self scanPast: #byteArrayStart.
			^ self parseByteArray].
	^ self parseLiteral: true! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseMessagePattern
	self isName
		ifTrue: [self parseUnaryMessagePattern]
		ifFalse: [self isBinary
				ifTrue: [self parseBinaryMessagePattern]
				ifFalse: [self failUnless: self isKeyword.
					self parseKeywordMessagePattern]]! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseMethodTemporaries
	currentTokenFirst == $|
		ifTrue: [self scanPast: #methodTempBar.
			[self isName]
				whileTrue: [self scanPast: #patternTempVar].
			self failUnless: currentToken = '|'.
			self scanPast: #methodTempBar]! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parsePragmaBinary
	self scanPast: #pragmaBinary.
	self isName
		ifTrue: [self
				scanPast: (self resolvePragmaArgument: currentToken)]
		ifFalse: [self parseLiteral: false].
	self failUnless: currentToken = '>'.
	self scanPast: #primitiveOrExternalCallEnd! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parsePragmaKeyword
	[self isKeyword]
		whileTrue: [self scanPast: #pragmaKeyword.
			self isName
				ifTrue: [self
						scanPast: (self resolvePragmaArgument: currentToken)]
				ifFalse: [self parseLiteral: false]].
	self failUnless: currentToken = '>'.
	self scanPast: #primitiveOrExternalCallEnd! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parsePragmaSequence
	[currentToken = '<']
		whileTrue: [self scanPast: #primitiveOrExternalCallStart.
			currentToken = 'primitive:'
				ifTrue: [self rangeType: #primitive.
					self parsePrimitive]
				ifFalse: [self isTokenExternalFunctionCallingConvention
						ifTrue: [self rangeType: #externalFunctionCallingConvention.
							self parseExternalCall]
						ifFalse: [self isName
								ifTrue: [self scanPast: #pragmaUnary.
									self failUnless: currentToken = '>'.
									self scanPast: #primitiveOrExternalCallEnd]
								ifFalse: [self isKeyword
										ifTrue: [self parsePragmaKeyword]
										ifFalse: [self isBinary
												ifTrue: [self parsePragmaBinary]
												ifFalse: [self error]]]]]]! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parsePrimitive
	self scanNext.
	currentTokenFirst isDigit
		ifTrue: [self scanPast: #integer]
		ifFalse: [self parseStringOrSymbol].
	currentToken = 'module:'
		ifTrue: [self scanPast: #module.
			self parseStringOrSymbol.
			currentToken = 'error:'
				ifTrue: [self scanPast: #primitive.
					self isName
						ifTrue: [self scanPast: #patternTempVar]
						ifFalse: [self parseStringOrSymbol]]]
		ifFalse: [currentToken = 'error:'
				ifTrue: [self scanPast: #module.
					self isName
						ifTrue: [self scanPast: #patternTempVar]
						ifFalse: [self parseStringOrSymbol].
					currentToken = 'module:'
						ifTrue: [self scanPast: #primitive.
							self parseStringOrSymbol]]].
	self failUnless: currentToken = '>'.
	self scanPast: #primitiveOrExternalCallEnd! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseStatement
	currentTokenFirst == $^
		ifTrue: [self scanPast: #return].
	self parseExpression! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseStatementList
	[[currentTokenFirst == $.]
		whileTrue: [self scanPast: #statementSeparator].
	(currentToken notNil
			and: [currentTokenFirst ~~ $]])
		ifTrue: [self parseStatement].
	currentTokenFirst == $.]
		whileTrue: [self scanPast: #statementSeparator]! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseStatementListForBraceArray
	[currentTokenFirst ~~ $}
		ifTrue: [self parseStatement].
	currentTokenFirst == $.]
		whileTrue: [self scanPast: #statementSeparator]! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseString
	| first c answer last |
	first := sourcePosition.
	answer := ''.
	[(c := self currentChar) isNil
		ifTrue: [self
				rangeType: #unfinishedString
				start: first - 1
				end: source size.
			self error].
	(c ~~ $'
			and: [answer := answer copyWith: c.
				true])
		or: [self peekChar == $'
				and: [sourcePosition := sourcePosition + 1.
					answer := answer copyWith: $'.
					true]]]
		whileTrue: [sourcePosition := sourcePosition + 1].
	last := sourcePosition.
	self nextChar.
	self
		scanPast: #string
		start: first - 1
		end: last.
	^ answer! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseStringOrSymbol
	currentTokenFirst == $'
		ifTrue: [^ self parseString].
	currentTokenFirst == $#
		ifTrue: [^ self parseSymbol].
	self error! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseSymbol
	| c |
	currentToken = '#'
		ifTrue: [self rangeType: #symbol.
			self scanWhitespace].
	c := self currentChar.
	self
		failWhen: (c isNil
				or: [c isSeparator]).
	c == $(
		ifTrue: [self nextChar.
			self
				scanPast: #arrayStart
				start: currentTokenSourcePosition
				end: currentTokenSourcePosition + 1.
			^ self parseArray].
	c == $[
		ifTrue: [self nextChar.
			self
				scanPast: #byteArrayStart
				start: currentTokenSourcePosition
				end: currentTokenSourcePosition + 1.
			^ self parseByteArray].
	c == $'
		ifTrue: [^ self parseSymbolString].
	((self isSelectorCharacter: c)
			or: [c == $-])
		ifTrue: [^ self parseSymbolSelector].
	(c isLetter
			or: [c == $:])
		ifTrue: [^ self parseSymbolIdentifier].
	^ self parseCharSymbol! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseSymbolIdentifier
	| c start end |
	c := self currentChar.
	self
		failUnless: (c isLetter
				or: [c == $:
						or: [c == $_]]).
	start := sourcePosition.
	[c := self nextChar.
	c isAlphaNumeric
		or: [c == $:
				or: [c == $_]]] whileTrue.
	end := sourcePosition - 1.
	c := source copyFrom: start - 1 to: end.
	self
		scanPast: #symbol
		start: start - 1
		end: end.
	^ c! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseSymbolSelector
	| start end |
	start := sourcePosition - 1.
	end := sourcePosition.
	[self isSelectorCharacter: self nextChar]
		whileTrue: [end := sourcePosition].
	self
		scanPast: #symbol
		start: start
		end: end! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseSymbolString
	| first c last |
	first := sourcePosition.
	self nextChar.
	[(c := self currentChar) isNil
		ifTrue: [self
				rangeType: #unfinishedString
				start: first
				end: source size.
			self error].
	c ~~ $'
		or: [self peekChar == $'
				and: [sourcePosition := sourcePosition + 1.
					true]]]
		whileTrue: [sourcePosition := sourcePosition + 1].
	last := sourcePosition.
	self nextChar.
	self
		scanPast: #stringSymbol
		start: first - 1
		end: last! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseTerm
	self failWhen: currentToken isNil.
	currentTokenFirst == $(
		ifTrue: [bracketDepth := bracketDepth + 1.
			self scanPast: #leftParenthesis level: bracketDepth.
			self parseExpression.
			self failUnless: currentTokenFirst == $).
			self scanPast: #rightParenthesis level: bracketDepth.
			^ bracketDepth := bracketDepth - 1].
	currentTokenFirst == $[
		ifTrue: [^ self parseBlock].
	currentTokenFirst == ${
		ifTrue: [self scanPast: #leftBrace.
			^ self parseBraceArray].
	self isName
		ifTrue: [^ self
				scanPast: (self resolve: currentToken)].
	self parseLiteral: false! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseUnary
	| unary type |
	[self isName]
		whileTrue: [unary := currentToken.
			type := #unary.
			(unary isEmpty
					or: [Symbol
							hasInterned: unary
							ifTrue: [:sym | nil]])
				ifFalse: [type := (Symbol thatStartsCaseSensitive: unary skipping: nil) isNil
								ifTrue: [#undefinedUnary]
								ifFalse: [#incompleteUnary]].
			self scanPast: type]! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
parseUnaryMessagePattern
	self scanPast: #patternUnary! !

!SHParserST80 methodsFor: 'scan' stamp: ''!
peekChar
	^ source
		at: sourcePosition + 1
		ifAbsent: [Character space]! !

!SHParserST80 methodsFor: 'parse support' stamp: ''!
pushArgument: aString 
	(arguments
		at: blockDepth
		ifAbsentPut: [OrderedCollection new: 10])
		add: aString! !

!SHParserST80 methodsFor: 'parse support' stamp: ''!
pushTemporary: aString 
	(temporaries
		at: blockDepth
		ifAbsentPut: [OrderedCollection new: 10])
		add: aString! !

!SHParserST80 methodsFor: 'recording ranges' stamp: ''!
rangeType: aSymbol 
	^ self
		rangeType: aSymbol
		start: currentTokenSourcePosition
		end: currentTokenSourcePosition + currentToken size - 1! !

!SHParserST80 methodsFor: 'recording ranges' stamp: ''!
rangeType: aSymbol start: s end: e 
	^ ranges
		add: (SHRange
				start: s
				end: e
				type: aSymbol)! !

!SHParserST80 methodsFor: 'parse' stamp: ''!
rangesIn: sourceString classOrMetaClass: aBehaviour workspace: aWorkspace environment: anEnvironmentOrNil 
	anEnvironmentOrNil
		ifNotNil: [environment := anEnvironmentOrNil].
	self workspace: aWorkspace;
		 classOrMetaClass: aBehaviour;
		 source: sourceString.
	self parse.
	^ ranges! !

!SHParserST80 methodsFor: 'identifier testing' stamp: ''!
resolve: aString 
	(#('self' 'super' 'true' 'false' 'nil' 'thisContext' ) includes: aString)
		ifTrue: [^ aString asSymbol].
	(self isBlockTempName: aString)
		ifTrue: [^ #blockTempVar].
	(self isBlockArgName: aString)
		ifTrue: [^ #blockArg].
	(self isMethodTempName: aString)
		ifTrue: [^ #tempVar].
	(self isMethodArgName: aString)
		ifTrue: [^ #methodArg].
	(instanceVariables includes: aString)
		ifTrue: [^ #instVar].
	workspace
		ifNotNil: [(workspace hasBindingOf: aString)
				ifTrue: [^ #workspaceVar]].
	Symbol
		hasInterned: aString
		ifTrue: [:sym | classOrMetaClass isBehavior
				ifTrue: [classOrMetaClass theNonMetaClass withAllSuperclasses
						do: [:c | 
							(c classPool bindingOf: sym)
								ifNotNil: [^ #classVar].
							c sharedPools
								do: [:p | (p bindingOf: sym)
										ifNotNil: [^ #poolConstant]].
							(c environment bindingOf: sym)
								ifNotNil: [^ #globalVar]]]
				ifFalse: [(environment bindingOf: sym)
						ifNotNil: [^ #globalVar]]].
	^ self resolvePartial: aString! !

!SHParserST80 methodsFor: 'identifier testing' stamp: ''!
resolvePartial: aString 
	(#('self' 'super' 'true' 'false' 'nil' 'thisContext' )
			anySatisfy: [:each | each beginsWith: aString])
		ifTrue: [^ #incompleteIdentifier].
	(self isIncompleteBlockTempName: aString)
		ifTrue: [^ #incompleteIdentifier].
	(self isIncompleteBlockArgName: aString)
		ifTrue: [^ #incompleteIdentifier].
	(self isIncompleteMethodTempName: aString)
		ifTrue: [^ #incompleteIdentifier].
	(self isIncompleteMethodArgName: aString)
		ifTrue: [^ #incompleteIdentifier].
	(instanceVariables
			anySatisfy: [:each | each beginsWith: aString])
		ifTrue: [^ #incompleteIdentifier].
	workspace
		ifNotNil: [(workspace hasBindingThatBeginsWith: aString)
				ifTrue: [^ #incompleteIdentifier]].
	classOrMetaClass isBehavior
		ifTrue: [classOrMetaClass theNonMetaClass withAllSuperclasses
				do: [:c | 
					(c classPool hasBindingThatBeginsWith: aString)
						ifTrue: [^ #incompleteIdentifier].
					c sharedPools
						do: [:p | 
							(p hasBindingThatBeginsWith: aString)
								ifTrue: [^ #incompleteIdentifier].
							nil].
					(c environment hasBindingThatBeginsWith: aString)
						ifTrue: [^ #incompleteIdentifier].
					nil]]
		ifFalse: [(environment hasBindingThatBeginsWith: aString)
				ifTrue: [^ #incompleteIdentifier]].
	^ #undefinedIdentifier! !

!SHParserST80 methodsFor: 'identifier testing' stamp: ''!
resolvePartialPragmaArgument: aString 
	(#('true' 'false' 'nil' )
			anySatisfy: [:each | each beginsWith: aString])
		ifTrue: [^ #incompleteIdentifier].
	classOrMetaClass isBehavior
		ifTrue: [classOrMetaClass theNonMetaClass withAllSuperclasses
				do: [:c | 
					(c environment hasBindingThatBeginsWith: aString)
						ifTrue: [^ #incompleteIdentifier].
					nil]]
		ifFalse: [(environment hasBindingThatBeginsWith: aString)
				ifTrue: [^ #incompleteIdentifier]].
	^ #undefinedIdentifier! !

!SHParserST80 methodsFor: 'identifier testing' stamp: ''!
resolvePragmaArgument: aString 
	(#('true' 'false' 'nil' ) includes: aString)
		ifTrue: [^ aString asSymbol].
	Symbol
		hasInterned: aString
		ifTrue: [:sym | classOrMetaClass isBehavior
				ifTrue: [classOrMetaClass theNonMetaClass withAllSuperclasses
						do: [:c | (c environment bindingOf: sym)
								ifNotNil: [^ #globalVar]]]
				ifFalse: [(environment bindingOf: sym)
						ifNotNil: [^ #globalVar]]].
	^ self resolvePartialPragmaArgument: aString! !

!SHParserST80 methodsFor: 'scan' stamp: ''!
scanBinary
	| c d |
	c := self currentChar.
	currentTokenSourcePosition := sourcePosition.
	currentToken := c asString.
	d := self nextChar.
	((self isSelectorCharacter: c)
			or: [c == $:])
		ifFalse: [^ currentToken].
	(c == $:
			and: [d == $=])
		ifTrue: [currentToken := currentToken , d asString.
			self nextChar.
			^ currentToken].
	c == $|
		ifTrue: [^ currentToken].
	[self isSelectorCharacter: d]
		whileTrue: [currentToken := currentToken , d asString.
			d := self nextChar].
	^ currentToken! !

!SHParserST80 methodsFor: 'scan' stamp: ''!
scanComment
	| c s e |
	s := sourcePosition.
	[sourcePosition := sourcePosition + 1.
	(c := self currentChar)
		ifNil: [self
				rangeType: #unfinishedComment
				start: s
				end: source size.
			^ self error].
	c == $"] whileFalse.
	e := sourcePosition.
	s < e
		ifTrue: [self
				rangeType: #comment
				start: s
				end: e].
	self nextChar.
	self scanWhitespace! !

!SHParserST80 methodsFor: 'scan' stamp: ''!
scanIdentifier
	| c start |
	start := sourcePosition.
	[(c := self nextChar) isAlphaNumeric
		or: [c == $_]] whileTrue.
	(c == $:
			and: [(self isSelectorCharacter: self peekChar) not])
		ifTrue: [self nextChar].
	currentToken := source copyFrom: start to: sourcePosition - 1.
	currentTokenSourcePosition := start! !

!SHParserST80 methodsFor: 'scan' stamp: ''!
scanNext
	self scanWhitespace.
	currentTokenFirst := self currentChar.
	currentTokenFirst isNil
		ifTrue: [currentTokenFirst := Character space.
			currentTokenSourcePosition := nil.
			currentToken := nil.
			^ nil].
	currentTokenFirst isDigit
		ifTrue: [^ self scanNumber].
	(currentTokenFirst isLetter
			or: [currentTokenFirst == $_])
		ifTrue: [^ self scanIdentifier].
	^ self scanBinary! !

!SHParserST80 methodsFor: 'scan' stamp: ''!
scanNumber
	| start c nc base |
	start := sourcePosition.
	self skipDigits.
	c := self currentChar.
	c == $r
		ifTrue: [base := Integer
						readFrom: (ReadStream
								on: (source copyFrom: start to: sourcePosition - 1)).
			self peekChar == $-
				ifTrue: [self nextChar].
			self skipBigDigits: base.
			c := self currentChar.
			c == $.
				ifTrue: [(self isBigDigit: self nextChar base: base)
						ifTrue: [self skipBigDigits: base]
						ifFalse: [sourcePosition := sourcePosition - 1]].
			c := self currentChar.
			('deq' includes: c)
				ifTrue: [((nc := self nextChar) isDigit
							or: [nc == $-
									and: [self peekChar isDigit]])
						ifTrue: [self skipDigits]
						ifFalse: [sourcePosition := sourcePosition - 1]].
			c == $s
				ifTrue: [self nextChar isDigit
						ifTrue: [self skipDigits]
						ifFalse: [sourcePosition := sourcePosition - 1]].
			currentToken := source copyFrom: start to: sourcePosition - 1.
			^ currentTokenSourcePosition := start].
	c == $s
		ifTrue: [self nextChar isDigit
				ifTrue: [self skipDigits]
				ifFalse: [sourcePosition := sourcePosition - 1].
			currentToken := source copyFrom: start to: sourcePosition - 1.
			^ currentTokenSourcePosition := start].
	c == $.
		ifTrue: [self nextChar isDigit
				ifTrue: [self skipDigits]
				ifFalse: [sourcePosition := sourcePosition - 1.
					currentToken := source copyFrom: start to: sourcePosition - 1.
					^ currentTokenSourcePosition := start]].
	c := self currentChar.
	('deq' includes: c)
		ifTrue: [((nc := self nextChar) isDigit
					or: [nc == $-
							and: [self peekChar isDigit]])
				ifTrue: [self skipDigits]
				ifFalse: [sourcePosition := sourcePosition - 1]].
	c == $s
		ifTrue: [self nextChar isDigit
				ifTrue: [self skipDigits]
				ifFalse: [sourcePosition := sourcePosition - 1]].
	currentToken := source copyFrom: start to: sourcePosition - 1.
	^ currentTokenSourcePosition := start! !

!SHParserST80 methodsFor: 'scan' stamp: ''!
scanPast: rangeType 
	rangeType = #blockPatternArg
		ifTrue: [self pushArgument: currentToken].
	rangeType = #blockPatternTempVar
		ifTrue: [self pushTemporary: currentToken].
	rangeType = #patternArg
		ifTrue: [self pushArgument: currentToken].
	rangeType = #patternTempVar
		ifTrue: [self pushTemporary: currentToken].
	^ self rangeType: rangeType;
		 scanNext! !

!SHParserST80 methodsFor: 'scan' stamp: ''!
scanPast: rangeType level: level 
	| cycle typePlusCycle |
	cycle := level <= 1
				ifTrue: [0]
				ifFalse: [level - 2 \\ 7 + 1].
	typePlusCycle := cycle = 0
				ifTrue: [rangeType]
				ifFalse: [(rangeType , cycle asString) asSymbol].
	^ self scanPast: typePlusCycle! !

!SHParserST80 methodsFor: 'scan' stamp: ''!
scanPast: rangeType start: startInteger end: endInteger 
	^ self
		rangeType: rangeType
		start: startInteger
		end: endInteger;
		 scanNext! !

!SHParserST80 methodsFor: 'scan' stamp: ''!
scanWhitespace
	| c |
	[c := self currentChar.
	c notNil
		and: [c isSeparator]]
		whileTrue: [sourcePosition := sourcePosition + 1].
	c == $"
		ifTrue: [self scanComment]! !

!SHParserST80 methodsFor: 'scan' stamp: ''!
skipBigDigits: baseInteger 
	[self isBigDigit: self nextChar base: baseInteger] whileTrue! !

!SHParserST80 methodsFor: 'scan' stamp: ''!
skipDigits
	[self nextChar isDigit] whileTrue! !

!SHParserST80 methodsFor: 'accessing' stamp: ''!
source
	^ source! !

!SHParserST80 methodsFor: 'accessing' stamp: ''!
source: aString 
	source := aString! !

!SHParserST80 methodsFor: 'accessing' stamp: ''!
workspace: aWorkspace 
	workspace := aWorkspace! !

Object subclass: #SHPreferences
	instanceVariableNames: ''
	classVariableNames: 'CustomStyleTable Groups'
	poolDictionaries: ''
	category: 'Shout-Styling'!

SHPreferences class
	instanceVariableNames: 'enabled'!

SHPreferences class
	instanceVariableNames: 'enabled'!

!SHPreferences class methodsFor: 'private' stamp: ''!
applyStyle
	SHTextStylerST80
		styleTable: (Groups values
				gather: [:group | group styleForTable])! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
argsStyle
	^ Groups at: #args! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
argsStyle: aGroupStyle 
	^ Groups at: #args put: aGroupStyle! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
commentStyle
	^ Groups at: #comment! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
commentStyle: aGroupStyle 
	^ Groups at: #comment put: aGroupStyle! !

!SHPreferences class methodsFor: 'private' stamp: ''!
customStyleTable
	^ CustomStyleTable! !

!SHPreferences class methodsFor: 'private' stamp: ''!
customStyleTable: anArray 
	CustomStyleTable := anArray.
	self initializeGroups! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
defaultStyle
	^ Groups at: #default! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
defaultStyle: aGroupStyle 
	^ Groups at: #default put: aGroupStyle! !

!SHPreferences class methodsFor: 'accessing' stamp: ''!
enabled
	^ enabled
		ifNil: [enabled := true]! !

!SHPreferences class methodsFor: 'accessing' stamp: ''!
enabled: aBoolean 
	enabled := aBoolean! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
errorStyle
	^ Groups at: #error! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
errorStyle: aGroupStyle 
	^ Groups at: #error put: aGroupStyle! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
globalVarStyle
	^ Groups at: #globalVar! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
globalVarStyle: aGroupStyle 
	^ Groups at: #globalVar put: aGroupStyle! !

!SHPreferences class methodsFor: 'initialization' stamp: ''!
initialize
	self customStyleTable: SHTextStylerST80 defaultStyleTable! !

!SHPreferences class methodsFor: 'initialization' stamp: 'AlainPlantec 9/20/2011 17:20'!
initializeGroups
	Groups := Dictionary new.
	#(#default #(#default ) #reservedWords #(#self #super #true #false #nil #thisContext ) #primitiveTypes #(#'$' #character #integer #number #- #symbol #stringSymbol #literalArray #string #unfinishedString ) #selectorPatterns #(#patternKeyword #patternBinary #patternUnary ) #messageSends #(#keyword #binary #unary #incompleteKeyword #incompleteBinary #incompleteUnary ) #primitiveOrModule #(#primitive #externalFunctionCallingConvention #module #externalCallType #externalCallTypePointerIndicator #primitiveOrExternalCallStart #primitiveOrExternalCallEnd ) #args #(#patternArg #methodArg #blockPatternArg #blockArg #argument ) #variable #(#blockTempVar #blockPatternTempVar #workspaceVar #tempVar #patternTempVar #incompleteIdentifier ) #instanceVar #(#instVar #classVar ) #globalVar #(#globalVar #poolConstant ) #comment #(#comment #unfinishedComment ) #error #(#invalid #excessCode #undefinedKeyword #undefinedBinary #undefinedUnary #undefinedIdentifier ) #syntax #(#assignment #ansiAssignment #literal #return #blockArgColon #leftParenthesis #rightParenthesis #leftParenthesis1 #rightParenthesis1 #leftParenthesis2 #rightParenthesis2 #leftParenthesis3 #rightParenthesis3 #leftParenthesis4 #rightParenthesis4 #leftParenthesis5 #rightParenthesis5 #leftParenthesis6 #rightParenthesis6 #leftParenthesis7 #rightParenthesis7 #blockStart #blockEnd #blockStart1 #blockEnd1 #blockStart2 #blockEnd2 #blockStart3 #blockEnd3 #blockStart4 #blockEnd4 #blockStart5 #blockEnd5 #blockStart6 #blockEnd6 #blockStart7 #blockEnd7 #arrayStart #arrayEnd #arrayStart1 #arrayEnd1 #byteArrayStart #byteArrayEnd #byteArrayStart1 #byteArrayEnd1 #leftBrace #rightBrace #cascadeSeparator #statementSeparator #methodTempBar #blockTempBar #blockArgsBar ) )
		pairsDo: [:gname :tokens | Groups
				at: gname
				put: (SHStyleElement withTokens: tokens)]! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
instanceVarStyle
	^ Groups at: #instanceVar! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
instanceVarStyle: aGroupStyle 
	^ Groups at: #instanceVar put: aGroupStyle! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
messageSendsStyle
	^ Groups at: #messageSends! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
messageSendsStyle: aGroupStyle 
	^ Groups at: #messageSends put: aGroupStyle! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
primitiveOrModuleStyle
	^ Groups at: #primitiveOrModule! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
primitiveOrModuleStyle: aGroupStyle 
	^ Groups at: #primitiveOrModule put: aGroupStyle! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
primitiveTypesStyle
	^ Groups at: #primitiveTypes! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
primitiveTypesStyle: aGroupStyle 
	^ Groups at: #primitiveTypes put: aGroupStyle! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
reservedWordsStyle
	^ Groups at: #reservedWords! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
reservedWordsStyle: aGroupStyle 
	^ Groups at: #reservedWords put: aGroupStyle! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
selectorPatternsStyle
	^ Groups at: #selectorPatterns! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
selectorPatternsStyle: aGroupStyle 
	^ Groups at: #selectorPatterns put: aGroupStyle! !

!SHPreferences class methodsFor: 'settings' stamp: 'StephaneDucasse 9/5/2011 18:28'!
settingsOn: aBuilder 
	<systemsettings>
	(aBuilder setting: #'Shout: Syntax Highlighting') target: self;
		 parentName: #codeBrowsing;
		 description: 'Syntax Highlighting As You Type: Enable syntax highlighting in browsers, debuggers and workspaces and set patterns style.';
		 selector: #enabled;
		 icon: UITheme current smallConfigurationIcon;
		
		with: [(aBuilder setting: #selectorPatternsStyle) label: 'Selector Patterns' translated;
				 description: 'Selector patterns in method pane' translated.
			(aBuilder setting: #errorStyle) label: 'Syntactic error' translated;
				 description: 'Invalid and undefined code' translated.
			(aBuilder setting: #argsStyle) label: 'Parameters' translated;
				 description: 'Parameters in patterns, message sends, and blocks' translated.
			(aBuilder setting: #commentStyle) label: 'Comments' translated;
				 description: 'Comments in code pane' translated.
			(aBuilder setting: #defaultStyle) label: 'Default' translated;
				 description: 'Default style' translated.
			(aBuilder setting: #globalVarStyle) label: 'Global variables' translated;
				 description: 'References to global variables, including classes' translated.
			(aBuilder setting: #instanceVarStyle) label: 'Instance/class variables' translated;
				 description: 'References to instance and class variables' translated.
			(aBuilder setting: #messageSendsStyle) label: 'Message sends' translated;
				 description: 'Message sends' translated.
			(aBuilder setting: #primitiveOrModuleStyle) label: 'Primitive or module' translated;
				 description: 'Primitive or module' translated.
			(aBuilder setting: #primitiveTypesStyle) label: 'Primitive types' translated;
				 description: 'Literal data' translated.
			(aBuilder setting: #reservedWordsStyle) label: 'Reserved words' translated;
				 description: 'Reserved words of the Smalltalk language' translated.
			(aBuilder setting: #syntaxStyle) label: 'Syntax' translated;
				 description: 'Any other syntactic element' translated.
			(aBuilder setting: #variableStyle) label: 'Variable' translated;
				 description: 'Temporary variable' translated]! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
syntaxStyle
	^ Groups at: #syntax! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
syntaxStyle: aGroupStyle 
	^ Groups at: #syntax put: aGroupStyle! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
variableStyle
	^ Groups at: #variable! !

!SHPreferences class methodsFor: 'accessing-styles' stamp: ''!
variableStyle: aGroupStyle 
	^ Groups at: #variable put: aGroupStyle! !

Object subclass: #SHRange
	instanceVariableNames: 'start end type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shout-Parsing'!

!SHRange class methodsFor: 'instance creation' stamp: ''!
start: s end: e type: aSymbol 
	^ self new
		start: s
		end: e
		type: aSymbol;
		 yourself! !

!SHRange methodsFor: 'accessing' stamp: ''!
end
	^ end! !

!SHRange methodsFor: 'accessing' stamp: ''!
end: anInteger 
	end := anInteger! !

!SHRange methodsFor: 'accessing' stamp: ''!
length
	^ end - start + 1! !

!SHRange methodsFor: 'accessing' stamp: ''!
start
	^ start! !

!SHRange methodsFor: 'accessing' stamp: ''!
start: anInteger 
	start := anInteger! !

!SHRange methodsFor: 'accessing' stamp: ''!
start: startInteger end: endInteger type: typeSymbol 
	start := startInteger.
	end := endInteger.
	type := typeSymbol! !

!SHRange methodsFor: 'accessing' stamp: ''!
type
	^ type! !

!SHRange methodsFor: 'accessing' stamp: ''!
type: aSymbol 
	type := aSymbol! !

Object subclass: #SHStyleElement 
	instanceVariableNames: 'tokens color emphasis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shout-Styling'!

!SHStyleElement  class methodsFor: 'settings' stamp: ''!
settingInputWidgetForNode: aSettingNode 
	| theme |
	theme := UITheme builder.
	^ theme newRow: {theme
			newColorChooserFor: aSettingNode realValue
			getColor: #color
			setColor: #color:
			help: 'Choose token color'. (theme
			newDropListFor: aSettingNode realValue
			list: #(#bold #italic #normal 'bold italic' )
			getSelected: #emphasis
			setSelected: #emphasis:
			getEnabled: nil
			useIndex: false
			help: 'Choose token emphasis') hResizing: #rigid;
			 width: 100}! !

!SHStyleElement  class methodsFor: 'instance-creation' stamp: ''!
withTokens: aCollection 
	^ self new tokens: aCollection;
		 yourself! !

!SHStyleElement  methodsFor: 'accessing' stamp: ''!
color
	^ color
		ifNil: [color := Color colorFrom: (SHPreferences customStyleTable
							detect: [:e | self tokens first = e first]) second]! !

!SHStyleElement  methodsFor: 'accessing' stamp: ''!
color: anObject 
	color := anObject.
	SHPreferences applyStyle! !

!SHStyleElement  methodsFor: 'accessing' stamp: ''!
emphasis
	| style |
	^ emphasis
		ifNil: [style := SHPreferences customStyleTable
						detect: [:e | self tokens first = e first].
			style size > 2
				ifTrue: [emphasis := style third.
					emphasis isSymbol
						ifFalse: [emphasis := ' ' join: emphasis].
					emphasis]
				ifFalse: [#normal]]! !

!SHStyleElement  methodsFor: 'accessing' stamp: ''!
emphasis: anObject 
	emphasis := anObject.
	SHPreferences applyStyle! !

!SHStyleElement  methodsFor: 'styling' stamp: ''!
emphasisAsArray
	^ self emphasis = 'bold italic'
		ifTrue: [#(#bold #italic )]
		ifFalse: [self emphasis]! !

!SHStyleElement  methodsFor: 'printing' stamp: 'StephaneDucasse 8/12/2011 17:55'!
printOn: aStream

	super printOn: aStream.
	color isNil
		ifFalse: [ aStream nextPutAll: ' color: ', color printString].
	emphasis isNil
		ifFalse: [ aStream nextPutAll: ' emphasis: ', emphasis printString].
	tokens isNil
		ifFalse: [ aStream nextPutAll: ' tokens: ', tokens printString]
	
	! !

!SHStyleElement  methodsFor: 'styling' stamp: ''!
styleForTable
	^ self tokens
		collect: [:token | 
			| style |
			style := OrderedCollection with: token.
			style add: self color.
			self emphasis
				ifNotNil: [style add: self emphasisAsArray].
			style asArray]! !

!SHStyleElement  methodsFor: 'accessing' stamp: ''!
tokens
	^ tokens! !

!SHStyleElement  methodsFor: 'accessing' stamp: ''!
tokens: anObject 
	tokens := anObject! !

Object subclass: #SHTextStyler
	instanceVariableNames: 'sem backgroundProcess text monitor view stylingEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shout-Styling'!

!SHTextStyler methodsFor: 'styling' stamp: ''!
evaluateWithoutStyling: aBlock 
	| t |
	t := stylingEnabled.
	stylingEnabled := false.
	^ aBlock
		ensure: [stylingEnabled := t]! !

!SHTextStyler methodsFor: 'formatting' stamp: ''!
format: aText 
	self terminateBackgroundStylingProcess.
	^ self privateFormat: aText! !

!SHTextStyler methodsFor: 'styling' stamp: ''!
initialize
	stylingEnabled := true! !

!SHTextStyler methodsFor: 'private' stamp: ''!
monitor
	monitor isNil
		ifTrue: [monitor := Monitor new].
	^ monitor! !

!SHTextStyler methodsFor: 'private' stamp: ''!
privateFormat: aText 
	self shouldBeImplemented! !

!SHTextStyler methodsFor: 'private' stamp: ''!
privateStyle: aText 
	self shouldBeImplemented! !

!SHTextStyler methodsFor: 'styling' stamp: ''!
style: aText 
	self terminateBackgroundStylingProcess.
	stylingEnabled
		ifTrue: [text := aText copy.
			self privateStyle: text.
			view
				ifNotNil: [view stylerStyled: text]]! !

!SHTextStyler methodsFor: 'styling' stamp: ''!
styleInBackgroundProcess: aText 
	self terminateBackgroundStylingProcess.
	stylingEnabled
		ifTrue: [text := aText copy.
			self monitor
				critical: [sem := Semaphore new.
					[sem notNil
						ifTrue: [sem wait.
							view
								ifNotNil: [view stylerStyledInBackground: text]]]
						forkAt: Processor activePriority.
					backgroundProcess := [self privateStyle: text.
							sem signal]
								forkAt: Processor userBackgroundPriority]]! !

!SHTextStyler methodsFor: 'styling' stamp: ''!
styledTextFor: aText 
	| formattedText |
	formattedText := self privateFormat: aText.
	self privateStyle: formattedText.
	^ formattedText! !

!SHTextStyler methodsFor: 'private' stamp: 'AlainPlantec 9/19/2011 19:29'!
stylingEnabled
	^ stylingEnabled! !

!SHTextStyler methodsFor: 'private' stamp: 'AlainPlantec 9/19/2011 19:29'!
stylingEnabled: aBoolean
	stylingEnabled := aBoolean! !

!SHTextStyler methodsFor: 'private' stamp: ''!
terminateBackgroundStylingProcess
	self monitor
		critical: [backgroundProcess
				ifNotNil: [backgroundProcess terminate.
					backgroundProcess := nil].
			sem
				ifNotNil: [sem terminateProcess.
					sem := nil]]! !

!SHTextStyler methodsFor: 'styling' stamp: ''!
unstyledTextFrom: aText 
	^ Text fromString: aText string! !

!SHTextStyler methodsFor: 'accessing' stamp: ''!
view: aViewOrMorph 
	view := aViewOrMorph! !

SHTextStyler subclass: #SHTextStylerST80
	instanceVariableNames: 'classOrMetaClass workspace font parser environment pixelHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shout-Styling'!

SHTextStylerST80 class
	instanceVariableNames: 'styleTable textAttributesByPixelHeight'!

SHTextStylerST80 class
	instanceVariableNames: 'styleTable textAttributesByPixelHeight'!

!SHTextStylerST80 class methodsFor: 'style table' stamp: ''!
attributeArrayForColor: aColorOrNil emphasis: anEmphasisSymbolOrArrayorNil font: aTextStyleOrFontOrNil 
	| emphArray answer |
	answer := Array new.
	aColorOrNil
		ifNotNil: [answer := answer , {TextColor color: aColorOrNil}].
	anEmphasisSymbolOrArrayorNil
		ifNotNil: [emphArray := anEmphasisSymbolOrArrayorNil isSymbol
						ifTrue: [{anEmphasisSymbolOrArrayorNil}]
						ifFalse: [anEmphasisSymbolOrArrayorNil].
			emphArray
				do: [:each | each ~= #normal
						ifTrue: [answer := answer , {TextEmphasis perform: each}]]].
	aTextStyleOrFontOrNil
		ifNotNil: [answer := answer , {TextFontReference toFont: aTextStyleOrFontOrNil}].
	^ answer! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: ''!
attributesFor: aSymbol pixelHeight: aNumber 
	^ (self textAttributesByPixelHeight
		at: aNumber
		ifAbsentPut: [self initialTextAttributesForPixelHeight: aNumber])
		at: aSymbol
		ifAbsent: []! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: 'BenjaminVanRyseghem 2/16/2011 11:04'!
defaultStyleTable
	"color can be a valid argument to Color class>>colorFrom: , or nil to
	use the editor text color.
	Multiple emphases can be specified using an array e.g. #(bold italic).
	If emphasis is not specified, #normal will be used.
	if pixel height is not specified , then the editor font size will be used.
	"
								
 ^ #(
       "(symbol        color           [emphasisSymbolOrArray          [textStyleName [pixelHeight]]])"                
       (default                                                                black           )
       (invalid                                                                red                     )
       (excessCode                                                             red                     )
       (comment                                                                (green muchDarker)              italic)
       (unfinishedComment                                      (red muchDarker)        italic)
       (#'$'                                                                   (red muchDarker)        )
       (character                                                              (red muchDarker)        )
       (integer                                                                        (red muchDarker)        )
       (number                                                         (red muchDarker)        )      
       (#-                                                                             (red muchDarker)        )
       (symbol                                                                 (blue muchDarker)                       normal)  
       (stringSymbol                                                   (blue muchDarker)                       normal)  
       (literalArray                                                   (blue muchDarker)                       normal)
       (string                                                                 (magenta muchDarker)    normal)
       (unfinishedString                                               red                     normal          )
       (assignment                                                             nil                     normal                    )
       (ansiAssignment                                                 nil                     normal)
       (literal                                                                        nil                     italic)
       (keyword                                                                (blue muchDarker)                       )
       (binary                                                                 (blue muchDarker)                       )      
       (unary                                                                  (blue muchDarker)                       )
       (incompleteKeyword                                              (gray muchDarker)                       underlined)
       (incompleteBinary                                               (gray muchDarker)                       underlined)    
       (incompleteUnary                                                (gray muchDarker)                       underlined)
       (undefinedKeyword                                               red                     )
       (undefinedBinary                                                red                     )      
       (undefinedUnary                                         red                     )                                                                                                      
       (patternKeyword                                                 nil                     bold)
       (patternBinary                                                  nil                     bold)
       (patternUnary                                                   nil                     bold)  
       (#self                                                                  (red muchDarker)        normal)
       (#super                                                                 (red muchDarker)        normal)
       (#true                                                                  (red muchDarker)        normal)
       (#false                                                                         (red muchDarker)        normal)
       (#nil                                                                   (red muchDarker)        normal)
       (#thisContext                                                   (red muchDarker)        normal)
       (#return                                                                (red muchDarker)        normal)
       (patternArg                                                     (blue muchDarker)                       italic)
       (methodArg                                                              (blue muchDarker)                       italic)
       (blockPatternArg                                                (blue muchDarker)                       italic)
       (blockArg                                                               (blue muchDarker)                       italic)
       (argument                                                               (blue muchDarker)                       italic)
       (blockArgColon                                                  black           )
       (leftParenthesis                                                        black           )
       (rightParenthesis                                               black           )
       (leftParenthesis1                                               (green muchDarker)              )
       (rightParenthesis1                                              (green muchDarker)              )
       (leftParenthesis2                                               (magenta muchDarker)            )
       (rightParenthesis2                                              (magenta muchDarker)            )
       (leftParenthesis3                                               (red muchDarker)                )
       (rightParenthesis3                                              (red muchDarker)                )
       (leftParenthesis4                                               (green darker)          )
       (rightParenthesis4                                              (green darker)          )
       (leftParenthesis5                                               (orange darker)         )
       (rightParenthesis5                                              (orange darker)         )
       (leftParenthesis6                                               (magenta darker)                )
       (rightParenthesis6                                              (magenta darker)                )
       (leftParenthesis7                                               blue            )
       (rightParenthesis7                                              blue            )
       (blockStart                                                             black           )
       (blockEnd                                                               black           )
       (blockStart1                                                            (green muchDarker)                      )
       (blockEnd1                                                              (green muchDarker)                      )
       (blockStart2                                                            (magenta muchDarker)            )
       (blockEnd2                                                              (magenta muchDarker)            )
       (blockStart3                                                            (red muchDarker)                )
       (blockEnd3                                                              (red muchDarker)                )
       (blockStart4                                                            (green darker)          )
       (blockEnd4                                                              (green darker)          )
       (blockStart5                                                            (orange darker)         )
       (blockEnd5                                                              (orange darker)         )
       (blockStart6                                                            (magenta darker)                )
       (blockEnd6                                                              (magenta darker)                )
       (blockStart7                                                            blue            )
       (blockEnd7                                                              blue            )                                                                                                                                                                                                                                                                                                                                                                                                      
       (arrayStart                                                             black           )
       (arrayEnd                                                               black           )
       (arrayStart1                                                    black           )
       (arrayEnd1                                                              black           )
       (leftBrace                                                              black           )
       (rightBrace                                                             black           )
       (cascadeSeparator                                               black           )
       (statementSeparator                                             black           )
       (externalCallType                                               black           )
       (externalCallTypePointerIndicator               black           )
       (primitiveOrExternalCallStart                   black   bold    )
       (primitiveOrExternalCallEnd                             black   bold    )
       (methodTempBar                                                  gray            )
       (blockTempBar                                                   gray            )
       (blockArgsBar                                                   gray            )
       (primitive                                                              (green muchDarker)              italic)
       (pragmaKeyword                                          (green muchDarker)              bold)
       (pragmaUnary                                                    (green muchDarker)              bold)
       (pragmaBinary                                                   (green muchDarker)              bold)                                                                  
       (externalFunctionCallingConvention              (green muchDarker)              bold)
       (module                                                                 (green muchDarker)              bold)
       (blockTempVar                                                   gray            italic)
       (blockPatternTempVar                                    gray            italic)
       (instVar                                                                black           normal)
       (workspaceVar                                                   black           bold)
       (undefinedIdentifier                                            red                     bold)
       (incompleteIdentifier                                   (gray darker)   (italic underlined))
       (tempVar                                                                (gray darker)   italic)
       (patternTempVar                                         (gray darker)   italic)
       (poolConstant                                                   (gray darker)   italic)
       (classVar                                                               (gray darker)   normal)
       (globalVar                                                              black           normal) )! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: ''!
initialTextAttributesForPixelHeight: aNumber 
	| d |
	d := IdentityDictionary new.
	self styleTable
		do: [:each | 
			| textStyle element emphasis font pixelHeight attrArray color textStyleName |
			element := each first.
			color := each
						at: 2
						ifAbsent: [].
			color := color
						ifNotNil: [Color colorFrom: color].
			emphasis := each
						at: 3
						ifAbsent: [].
			textStyleName := each
						at: 4
						ifAbsent: [].
			pixelHeight := each
						at: 5
						ifAbsent: [aNumber].
			textStyleName
				ifNil: [pixelHeight := nil].
			textStyle := TextStyle named: textStyleName.
			font := textStyle
						ifNotNil: [pixelHeight
								ifNotNil: [textStyle fontOfSize: pixelHeight]].
			attrArray := self
						attributeArrayForColor: color
						emphasis: emphasis
						font: font.
			attrArray notEmpty
				ifTrue: [d at: element put: attrArray]].
	^ d! !

!SHTextStylerST80 class methodsFor: 'initialization' stamp: 'AlainPlantec 8/27/2011 15:57'!
initialize
	"self initialize"
	styleTable := nil.
	textAttributesByPixelHeight := nil.
	(PluggableTextMorph respondsTo: #stylingClass:)
		ifTrue: [ PluggableTextMorph stylingClass: self ]! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: ''!
styleTable
	^ styleTable
		ifNil: [styleTable := self defaultStyleTable]! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: ''!
styleTable: anArray 
	styleTable := anArray.
	textAttributesByPixelHeight := nil! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: ''!
textAttributesByPixelHeight
	^ textAttributesByPixelHeight
		ifNil: [textAttributesByPixelHeight := Dictionary new]! !

!SHTextStylerST80 class methodsFor: 'initialization' stamp: 'AlainPlantec 8/27/2011 16:56'!
unload
	(PluggableTextMorph respondsTo: #stylingClass:)
		ifTrue: [ PluggableTextMorph stylingClass: nil ]
	! !

!SHTextStylerST80 methodsFor: 'private' stamp: ''!
attributesFor: aSymbol 
	^ self class attributesFor: aSymbol pixelHeight: self pixelHeight! !

!SHTextStylerST80 methodsFor: 'accessing' stamp: ''!
classOrMetaClass: aBehavior 
	classOrMetaClass := aBehavior! !

!SHTextStylerST80 methodsFor: 'accessing' stamp: ''!
environment: anObject 
	environment := anObject! !

!SHTextStylerST80 methodsFor: 'accessing' stamp: ''!
font: aFont 
	font := aFont! !

!SHTextStylerST80 methodsFor: 'private' stamp: ''!
parseableSourceCodeTemplate
	^ 'messageSelectorAndArgumentNames
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!SHTextStylerST80 methodsFor: 'private' stamp: ''!
pixelHeight
	^ pixelHeight
		ifNil: [pixelHeight := (font
						ifNil: [TextStyle defaultFont]) pixelSize]! !

!SHTextStylerST80 methodsFor: 'private' stamp: ''!
privateFormat: aText 
	aText asString = Object sourceCodeTemplate
		ifTrue: [^ self parseableSourceCodeTemplate asText].
	^ aText! !

!SHTextStylerST80 methodsFor: 'private' stamp: ''!
privateStyle: aText 
	| ranges |
	ranges := self rangesIn: aText setWorkspace: true.
	ranges
		ifNotNil: [self setAttributesIn: aText fromRanges: ranges]! !

!SHTextStylerST80 methodsFor: 'private' stamp: ''!
rangesIn: aText setWorkspace: aBoolean 
	parser
		ifNil: [parser := SHParserST80 new].
	^ parser
		rangesIn: aText asString
		classOrMetaClass: classOrMetaClass
		workspace: (aBoolean
				ifTrue: [workspace])
		environment: environment! !

!SHTextStylerST80 methodsFor: 'private' stamp: ''!
setAttributesIn: aText fromRanges: ranges 
	| charAttr defaultAttr newRuns newValues lastAttr oldRuns lastCount attr |
	oldRuns := aText runs.
	defaultAttr := self attributesFor: #default.
	charAttr := Array new: aText size.
	1
		to: charAttr size
		do: [:i | charAttr at: i put: defaultAttr].
	ranges
		do: [:range | (attr := self attributesFor: range type)
				ifNotNil: [range start
						to: range end
						do: [:i | charAttr at: i put: attr].
					nil]].
	newRuns := OrderedCollection new: charAttr size // 10.
	newValues := OrderedCollection new: charAttr size // 10.
	1
		to: charAttr size
		do: [:i | 
			attr := charAttr at: i.
			i = 1
				ifTrue: [newRuns add: 1.
					lastCount := 1.
					lastAttr := newValues add: attr]
				ifFalse: [attr == lastAttr
						ifTrue: [lastCount := lastCount + 1.
							newRuns at: newRuns size put: lastCount]
						ifFalse: [newRuns add: 1.
							lastCount := 1.
							lastAttr := newValues add: attr]]].
	aText
		runs: (RunArray runs: newRuns values: newValues).
	oldRuns
		withStartStopAndValueDo: [:start :stop :attribs | (attribs
				detect: [:each | each shoutShouldPreserve]
				ifNone: [])
				ifNotNil: [attribs
						do: [:eachAttrib | aText
								addAttribute: eachAttrib
								from: start
								to: stop]]]! !

!SHTextStylerST80 methodsFor: 'accessing' stamp: ''!
sourceMap: aSortedCollection 
	^ self! !

!SHTextStylerST80 methodsFor: 'converting' stamp: ''!
unstyledTextFrom: aText 
	| answer |
	answer := super unstyledTextFrom: aText.
	aText runs
		withStartStopAndValueDo: [:start :stop :attribs | (attribs
				detect: [:each | each isKindOf: TextAction]
				ifNone: [])
				ifNotNil: [attribs
						do: [:eachAttrib | answer
								addAttribute: eachAttrib
								from: start
								to: stop]]].
	^ answer! !

!SHTextStylerST80 methodsFor: 'accessing' stamp: ''!
workspace: aWorkspace 
	workspace := aWorkspace! !

!ThreadSafeTranscript methodsFor: '*Shout-Styling' stamp: 'AlainPlantec 8/27/2011 00:20'!
shoutAboutToStyle: aPluggableShoutMorphOrView 
	^ false! !
SHPreferences initialize!
SHTextStylerST80 initialize!
